#include "track.h"
#include <fstream>

TrackList::TrackList (char *fileName, AlbumList &al)
: albums (al)
{
   ifstream s (fileName);
   try  { for (;;) tracks.push_back (s); }
   catch (EOFException) {}
   for (Track &track: tracks)  track.lookupAlbum (al);
}

struct TrackOrder
{  bool operator() (const Track *a, const Track *b) const
   { return *a < *b; }
};

void TrackList::print (ostream &o) const
{
   set<const Track *, TrackOrder> ts;
   for (const Track &track: tracks)  ts.insert (&track);
   const Album *a = 0;
   for (const Track *t: ts)
   {  if (t->getAlbum () != a)
      { a = t->getAlbum ();  o << *a; }
      o << *t;
   }
}
